#include "bloom.h"
#include "bloomset.h"
#include <fcntl.h>
#include <assert.h>

bloomset_element::bloomset_element(Action anAction,const char *fname)
{
    action = anAction;
    bloom = nsrl_bloom_alloc();
    nsrl_bloom_open(bloom,fname,O_RDONLY);
}


bool bloomset::check_exclude(const unsigned char *hash)
{
    int include_count = 0;
    int exclude_count = 0;
    for(bloomset::const_iterator it = this->begin();
	it != this->end();
	it++){
	switch((*it)->action){
	case bloomset_element::INCLUDE:
	    include_count++;
	    if((*it)->query(hash)) return false; // do not exclude
	    break;
	case bloomset_element::EXCLUDE:
	    exclude_count++;
	    if((*it)->query(hash)) return true; // do exclude
	    break;
	default:
	    assert(0);			// that's bad
	}
    }
    if(include_count>0) return true;	// there were include filters, and this wasn't in it, so exclude
    return false;
}
